/*
**      This program is intended to act as a wrapper for the game abuse
**	from crack.com.
**
**	this wrapper will setup the mouse and switch to real uid root
**	to avoid the need to have the root password just to play a game.
**
**	the real hack was the mouse support.  this will first check if
**	a mouse enviroment is needed (svga version), then see if one is
**	already provided, and failing that it will go check libvga.config
**	and setup the environment using the info found there.
**
**      while the author hopes this program is useful, the author will
**      not be held accountable for any damages incurred by use of this
**      program, incidental or otherwise.  use at your own risk.
**
**      Author: jcoy@red.cscwc.pima.edu
**      Copying-policy: GNU PUBLIC LICENSE
*/
#include "abuse.h"

int Argc;			/* i need these globally */
char **Argv;

/* main:  totally stripped down pattern of events for this program. */
int
main(int argc, char **argv)
{
    int mouse_type;
    FILE *fp_abuse;

    Argc = argc;
    Argv = argv;

    if (Parse_Env())		/* just exec it if things are setup */
	Exec_Abuse(-1);

    if ((fp_abuse = Get_Config_Fp()) == NULL) {
	fprintf(stderr, "Couldn't find a valid libvga.config\n");
	Exec_Abuse(-1);		/* if no libvga.config found */
    }

    mouse_type = Parse_Config(fp_abuse);
    Exec_Abuse(mouse_type);

    return 0;		/* for compilers sake */
}

/* Get_Config_Fp:  locate & open libvga.config, return file descriptor */
FILE *Get_Config_Fp(void)
{
    int i;
    FILE *Config_Fp;
    unsigned char *List[] = {
	"/etc/vga/libvga.config",
	"/usr/local/lib/libvga.config",
	"/usr/lib/libvga.config",
	""
    };

    for (i = 0; *List[i]; i++)
	if ((Config_Fp = fopen(List[i], "r")) != NULL)
	    return Config_Fp;
    return NULL;
}

/* Parse_Env:  test environment for acceptable settings */
unsigned char *Parse_Env(void)
{
    int MouseNum;
    unsigned char *Display_Env, *Mouse_Env;
    
#ifdef DEBUG	/* for debugging under X */
    Mice_Size = sizeof(Mice) / sizeof(struct Mouse_Type);
    return NULL;
#endif

    strcpy(Abuse_Path, ABUSE_DIR);	/* prep argv[0] for execv() */
    strcat(Abuse_Path, "/");
    if ((Display_Env = getenv("DISPLAY")) != NULL) {
	strcat(Abuse_Path, X_ABUSE);	/* X version */
	*Argv = X_ABUSE;
	return Display_Env;		/* ready to go, return anything */
    }
    strcat(Abuse_Path, SVGA_ABUSE);	/* svgalib version */
    *Argv = SVGA_ABUSE;
    
    Mice_Size = sizeof(Mice) / sizeof(struct Mouse_Type);
    if ((Mouse_Env = getenv(MOUSE_ENV_NAME)) != NULL) {
	/* we got something- check if valid */
	for (MouseNum = 0; MouseNum < Mice_Size; MouseNum++) { 
	    if (!strcmp(Mouse_Env, Mice[MouseNum].Abuse))
		return Mouse_Env;
	}
	unsetenv(MOUSE_ENV_NAME);       /* clear invalid setting */
    }
    return NULL;
}

/* Exec_Abuse:  set up environment for & exec abuse */
void Exec_Abuse(int Mouse)
{
    uid_t User;
        
    if (Mouse > 0) {
	printf("defining mouse as %s\n", Mice[Mouse].Human);
	setenv(MOUSE_ENV_NAME, Mice[Mouse].Abuse, 1);
    }

    if ((User=getuid()) != 0) {
	User = geteuid();
	setuid(User);
    }

    if (User) {
	if (strcmp(X_ABUSE, *Argv) != 0) { 
	    fprintf(stderr, "Can't get I/O permissions for console version.\n");
            exit(1);
	} else
	    fprintf(stderr, "binary isn't setuid root... but I'll try\n");
    }

    setenv("PATH", ".:/bin:/usr/bin", 1);       /* restrict path */
    
    if (chdir(ABUSE_DIR)) {	/* change to abuse directory */
	perror("chdir");
	fprintf(stderr, "Could not chdir(%s)\n", ABUSE_DIR);
	exit(1);
    }

    execv(Abuse_Path, Argv);	/* exec abuse */
    
    /* execv only falls through on error */
    perror("execv");
    fprintf(stderr, "Could not execv(%s)\n", Abuse_Path);
    exit(1);
}

/*  Parse_Config:  read config file & return Mouse_Type offset
 *                 note that the only interesting line in libvga.config
 *                 is the one that starts with a lowercase 'm'.
 */
int Parse_Config(FILE *Config_Fp)
{
    unsigned char *buff;
    int MouseNum;

    buff=malloc(STRINGSIZ);
    while(1) {
	if((fgets(buff, STRINGSIZ, Config_Fp)) == NULL)
	    break;
	while(isspace(*buff))	/* clear whitespace */
	    buff++;
	if (*buff == 'm') {	/* is this it? */
	    MouseNum = Get_Mouse_Type(buff);
	    free(buff);		/* even small leaks are bad */
	    return MouseNum;
	}
    }
    return -1;			/* nothing useful */
}

/* Get_Mouse_Type:  convert mouse line form libvga.config to Mouse index */
int Get_Mouse_Type(unsigned char *Buffer)
{
    int PastFirst=0;	/* flag specifies past first word */
    
    while (isspace(*(Buffer)))		/* skip white space */
	Buffer++;

    for ( ; *Buffer; Buffer++) {
	if (isdigit(*Buffer))		/* mouse type in digit form */
	    return Test_Digit(*Buffer);
	if (isspace(*Buffer))
	    PastFirst = 1;		/* past the first word */
	if (PastFirst && isalpha(*Buffer))  /* is this 2nd word and alpha? */
	    return Test_Alpha(Buffer);
    }
    return -1;
}

/* Test_Digit:  test digit from libvga.config to get Mice offset */
int Test_Digit(int digit)
{
    int MouseNum;
    
    digit-='0';	/* convert character to int */
    for (MouseNum=0; MouseNum < Mice_Size; MouseNum++) {
	if (digit == Mice[MouseNum].Num)	/* test for known mouse type */
	    return MouseNum;
    }
    return -1;
}

/* Test_Alpha:  test string from libvga.config to get Mice offset 
**
**              i keep wanting to change the SVGA members of Mice[]
**              to all lowercase to avoid that extra function call,
**              but it's just something else to remember if i ever
**              modify the Mice struct.
**/
int Test_Alpha(unsigned char *Buffer)
{
    int MiceNum, n;		/* n is just an index for a pointer */

    for (MiceNum=0; MiceNum < Mice_Size; MiceNum++) {
	n=0;	/* reset counter */
	while (*(Mice[MiceNum].SVGA+n) != '\0') {
	    if ( tolower(*(Mice[MiceNum].SVGA+n)) == tolower(*(Buffer+n)) )
		n++;
	    else
		break;		/* no match */
	}
	if ( *(Mice[MiceNum].SVGA+n) == '\0') /* if null, it matched */
	    return MiceNum;
    }
    return -1;
}
